Edit

Share via


Domains - Role Assignments Bulk Assign

Assign the specified admins or contributors to the domain.

Permissions

The caller must be a Fabric administrator.

Required Delegated Scopes

Tenant.ReadWrite.All.

Limitations

Maximum 25 requests per one minute per principal.

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities Yes

Interface

POST https://api.fabric.microsoft.com/v1/admin/domains/{domainId}/roleAssignments/bulkAssign

URI Parameters

Name In Required Type Description
domainId
path True

string (uuid)

The domain ID.

Request Body

Name Required Type Description
type True

DomainRole

The update request type.

principals Principal[]:

The principals that will be assigned to the domain role.

Responses

Name Type Description
200 OK

Request completed successfully.

429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • PrincipalWithDomainRoleAssignmentAlreadyExists - The principal is already assigned to the domain with the specified role.

  • UnsupportedPrincipalTypeForDomainAdminAssignment - Using unsupported principal type for assigning or unassigning domain admin roles.

  • UnknownError - An error occurred.

Examples

Assign domain admins example
Assign domain contributors example

Assign domain admins example

Sample request

POST https://api.fabric.microsoft.com/v1/admin/domains/97dd1d38-a4c6-41ed-bc4f-1e383f8ddd0f/roleAssignments/bulkAssign

{
  "type": "Admins",
  "principals": [
    {
      "id": "796ce6ad-9163-4c16-9559-c68192a251de",
      "type": "User"
    }
  ]
}

Sample response

Assign domain contributors example

Sample request

POST https://api.fabric.microsoft.com/v1/admin/domains/97dd1d38-a4c6-41ed-bc4f-1e383f8ddd0f/roleAssignments/bulkAssign

{
  "type": "Contributors",
  "principals": [
    {
      "id": "796ce6ad-9163-4c16-9559-c68192a251de",
      "type": "User"
    }
  ]
}

Sample response

Definitions

Name Description
DomainRole

Represents the domain members by the principal's request type. Additional request types may be added over time.

DomainRoleAssignmentRequest

The request payload for assigning domain members for a domain by principal.

EntireTenantPrincipal

Represents a tenant principal

ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

GroupPrincipal

Represents a security group.

GroupType

The type of the group. Additional group types may be added over time.

PrincipalType

The type of the principal. Additional principal types may be added over time.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

UserDetails

User principal specific details. Applicable when the principal type is User.

UserPrincipal

Represents a Microsoft Entra user principal.

DomainRole

Represents the domain members by the principal's request type. Additional request types may be added over time.

Value Description
Admin

Domain admin.

Contributor

Domain contributor.

DomainRoleAssignmentRequest

The request payload for assigning domain members for a domain by principal.

Name Type Description
principals Principal[]:

The principals that will be assigned to the domain role.

type

DomainRole

The update request type.

EntireTenantPrincipal

Represents a tenant principal

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

EntireTenant

The type of the principal. Additional principal types may be added over time.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

Name Type Description
groupType

GroupType

The type of the group. Additional group types may be added over time.

GroupPrincipal

Represents a security group.

Name Type Description
displayName

string

The principal's display name.

groupDetails

GroupDetails

Group specific details. Applicable when the principal type is Group.

id

string (uuid)

The principal's ID.

type string:

Group

The type of the principal. Additional principal types may be added over time.

GroupType

The type of the group. Additional group types may be added over time.

Value Description
Unknown

Principal group type is unknown.

SecurityGroup

Principal is a security group.

DistributionList

Principal is a distribution list.

PrincipalType

The type of the principal. Additional principal types may be added over time.

Value Description
User

Principal is a Microsoft Entra user principal.

ServicePrincipal

Principal is a Microsoft Entra service principal.

Group

Principal is a security group.

ServicePrincipalProfile

Principal is a service principal profile.

EntireTenant

Principal represents all tenant users.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

Name Type Description
aadAppId

string (uuid)

The service principal's Microsoft Entra AppId.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalDetails

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

type string:

ServicePrincipal

The type of the principal. Additional principal types may be added over time.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

Name Type Description
parentPrincipal Principal:

The service principal profile's parent principal.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalProfileDetails

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

type string:

ServicePrincipalProfile

The type of the principal. Additional principal types may be added over time.

UserDetails

User principal specific details. Applicable when the principal type is User.

Name Type Description
userPrincipalName

string

The user principal name.

UserPrincipal

Represents a Microsoft Entra user principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

User

The type of the principal. Additional principal types may be added over time.

userDetails

UserDetails

User principal specific details. Applicable when the principal type is User.